//+------------------------------------------------------------------+
//|                                                          opt.mq4 |
//|                                   Copyright 2013-2014, keekkenen |
//|                                    http://forum.forexpeoples.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013-2014, keekkenen"
#property link      "http://forum.forexpeoples.ru/"
#property version   "2.00"
#property strict
#property indicator_chart_window
//+------------------------------------------------------------------+
enum Styles
  {
   dot=STYLE_DOT,// 
   dash=STYLE_DASH,// 
   dashdot=STYLE_DASHDOT,//- 
   dashdotdot=STYLE_DASHDOTDOT,//-    
   solid=STYLE_SOLID// 
  };
//+------------------------------------------------------------------+ 
extern double chartShift = 42;
extern int stepHisto = 10;
extern string file="EURUSD.csv";//   
extern string file2="EURUSD2.csv";//   
extern string file3="EURUSD3.csv";//   
extern string token=";";//    
extern int shiftCountBar=20;//    0-  
extern int drawCountBar=20; //   
extern color lColor=Red;// put 
extern Styles lStyle=solid;// put 
extern int lWidth=2;// put 
extern color rColor=Blue;// call 
extern Styles rStyle=solid;// call 
extern int rWidth=2;// call 
extern int reloadTime=0;// ()    
//+------------------------------------------------------------------+ 
int OnInit()
  {
   if(reloadTime==0)
     {
      reloadTime=Period()*60;
     }
   ChartSetDouble(0,CHART_SHIFT_SIZE,chartShift);  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+  
void OnDeinit(const int reason)
  {
   objectsDelete(WindowExpertName());
  }
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   if(isTime(reloadTime,true))
     {
     int step = 0;
      showData(file,step,shiftCountBar);
      step += shiftCountBar + stepHisto;
      showData(file2,step,shiftCountBar);
      step += shiftCountBar + stepHisto;
      showData(file3,step,shiftCountBar);
      
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+
void showData(string fileName,int zeroBar,int shiftBar)
  {
   double lPrice[],lVol[],rPrice[],rVol[];
   double max=EMPTY;
   int i=0;

   getdData(fileName,lPrice,lVol,rPrice,rVol);

   if(ArraySize(lPrice)==0 && ArraySize(rPrice)==0)
     {
      return;
     }

   for(i=0;i<ArraySize(lVol);i++)
     {
      if(max<lVol[i])
        {
         max=lVol[i];
        }
     }

   for(i=0;i<ArraySize(rVol);i++)
     {
      if(max<rVol[i])
        {
         max=rVol[i];
        }
     }
   int time;
   if(zeroBar==0)
     {
      time=int(Time[zeroBar]+shiftBar*Period()*60);
     }
   else
     {
      time=int(Time[0]+(zeroBar+shiftBar)*Period()*60);
     }

   for(i=0;i<ArraySize(lVol);i++)
     {
      drawLine(WindowExpertName()+"_"+IntegerToString(zeroBar)+"l"+IntegerToString(i),0,OBJ_TREND,time,lPrice[i],lColor,
               time -(int)MathFloor(lVol[i]*drawCountBar/max)*Period()*60,lPrice[i],false,false,(int)lStyle,lWidth);
     }

   i=ArrayMaximum(lVol);
   setArrow(WindowExpertName()+"_"+IntegerToString(zeroBar)+"lm",0,time,lPrice[i],lColor,6,1);

   for(i=0;i<ArraySize(rVol);i++)
     {
      drawLine(WindowExpertName()+"_"+IntegerToString(zeroBar)+"r"+IntegerToString(i),0,OBJ_TREND,time,rPrice[i],rColor,
               time -(int)MathFloor(rVol[i]*drawCountBar/max)*Period()*60,rPrice[i],false,false,(int)rStyle,rWidth);
     }
   i=ArrayMaximum(rVol);
   setArrow(WindowExpertName()+"_"+IntegerToString(zeroBar)+"rm",0,time,rPrice[i],rColor,6,1);
  }
//+------------------------------------------------------------------------------+
void setArrow(string name,int window,datetime time,double price,
              color col,int arrIndex,int width=0)
  {
   if(ObjectFind(name)==EMPTY)
      ObjectCreate(name,OBJ_ARROW,window,time,price);
   ObjectSet(name,OBJPROP_ARROWCODE,arrIndex);
   ObjectSet(name,OBJPROP_COLOR,col);
   ObjectSet(name,OBJPROP_WIDTH,width);
   ObjectMove(name,0,time,price);
  }
//+------------------------------------------------------------------------------+
void drawLine(string name,int window,int lineType,datetime time1,
              double price1,color col,datetime time2,double price2,
              bool back=false,bool ray=false,int style=0,int width=0)
  {
   if(ObjectFind(name)==EMPTY)
      ObjectCreate(name,lineType,window,0,0,0,0);
   ObjectSet(name,OBJPROP_PRICE1,price1);
   ObjectSet(name,OBJPROP_PRICE2,price2);
   ObjectSet(name,OBJPROP_TIME1,time1);
   ObjectSet(name,OBJPROP_TIME2,time2);
   ObjectSet(name,OBJPROP_STYLE,style);
   ObjectSet(name,OBJPROP_COLOR,col);
   ObjectSet(name,OBJPROP_WIDTH,width);
   ObjectSet(name,OBJPROP_BACK,back);
   ObjectSet(name,OBJPROP_RAY,ray);
  }
//+------------------------------------------------------------------+
void getdData(string fileName,double &lPrice[],double &lVol[],double &rPrice[],double &rVol[])
  {
   int h=INVALID_HANDLE,count=0;
   string value="";
   string res[];

   ArrayResize(lPrice,0); ArrayResize(lVol,0); ArrayResize(rPrice,0); ArrayResize(rVol,0);

   if(!FileIsExist(fileName))
     {
      return;
     }

   h=FileOpen(fileName,FILE_READ|FILE_CSV,"\r\n");
   if(h==INVALID_HANDLE)
     {
      return;
     }

   for(;true;)
     {
      if(FileIsEnding(h))
        {
         break;
        }
      value=FileReadString(h);
      if(value=="")
        {
         continue;
        }
      count=StringReplace(value,",",".");
      StringSplit(value,StringGetChar(token,0),res);

      if(ArraySize(res)<16) continue;
      if(res[1]=="" && res[7]=="" && res[9]=="" && res[15]=="")
        {
         continue;
        }

      string a1=res[1],a7=res[7],a9=res[9],a15=res[15];

      if(res[1]!="" && res[7]!="" && isNumber(res[1]) && isNumber(res[7]))
        {
         ArrayResize(lPrice,ArraySize(lPrice)+1);
         lPrice[ArraySize(lPrice)-1]=StrToDouble(res[1]);
         ArrayResize(lVol,ArraySize(lVol)+1);
         lVol[ArraySize(lVol)-1]=StrToDouble(res[7]);
        }

      if(res[9]!="" && res[15]!="" && isNumber(res[9]) && isNumber(res[15]))
        {
         ArrayResize(rPrice,ArraySize(rPrice)+1);
         rPrice[ArraySize(rPrice)-1]=StrToDouble(res[15]);
         ArrayResize(rVol,ArraySize(rVol)+1);
         rVol[ArraySize(rVol)-1]=StrToDouble(res[9]);
        }
     }
   if(h!=INVALID_HANDLE)
     {
      FileClose(h);
     }
  }
//+------------------------------------------------------------------+
bool isNumber(string value)
  {
   double i=StringToDouble(value);

   return(i!=0);
  }
//+------------------------------------------------------------------+
bool isTime(int sec,bool isInd=false)
  {
   bool res=false;
   static int time=0;

   if(time==0)
     {
      time= int(Time[0]+sec);
      res = isInd;
        } else {
      if(TimeCurrent()>=time)
        {
         time= int(TimeCurrent()+sec);
         res = true;
        }
     }
   return(res);
  }
//+------------------------------------------------------------------+
void objectsDelete(string search)
  {
   int total=ObjectsTotal()-1,i=0;
   string name="";

   for(i=ObjectsTotal()-1; i>=0; i--)
     {
      name=ObjectName(i);
      int pos=StringFind(name,search);
      if(StringFind(name,search)==0)
        {
         ObjectDelete(name);
        }
     }
  }
//+------------------------------------------------------------------+
